%define plf 0
%define enable_extrusion 1
%define disable_inappropriate 1
# Allow --with[out] <feature> at rpm command line build
%{?_with_plf: %{expand: %%global plf 1}}
%{?_without_plf: %{expand: %%global plf 0}}
%{?_with_extrusion: %{expand: %%global enable_extrusion 1}}
%{?_without_extrusion: %{expand: %%global enable_extrusion 0}}
%{?_with_inappropriate: %{expand: %%global disable_inappropriate 0}}
%{?_without_inappropriate: %{expand: %%global disable_inappropriate 1}}

%if %plf
%define distsuffix plf
%define disable_inappropriate 0
%endif
%if "%distro_section" == "tainted"
%global plf 1
%global disable_inappropriate 0
%endif

Summary:	A set of X Window System screen savers
Name:		xscreensaver
Version:	5.36
Release:	%mkrel 2
License:	BSD
Group:		Graphical desktop/Other
URL:		http://www.jwz.org/xscreensaver/
Source0:	http://www.jwz.org/xscreensaver/%{name}-%{version}.tar.gz
#Patch0:		xscreensaver-5.05-mdv-alt-drop_setgid.patch
# (fc) 4.00-4mdk allow root to start xscreensaver
Patch1:		xscreensaver-4.23-root.patch
# (fc) 4.05-3mdk disable openGL hacks by default
Patch2:		xscreensaver-5.09-noGL.patch
# (fc) 4.05-4mdk don't show screen savers that aren't available
#Patch3:		xscreensaver-4.01-avail.patch
# (fc) 4.23-1mdk disable inappropriate stuff (Mdk bug #19866)
Patch4:		xscreensaver-5.00-inappropriate.patch
# Only Themed should be enabled
Patch5:		xscreensaver-5.33-defaultconfig.patch
Patch8:		xscreensaver-5.33-desktop-file.patch
Patch9:		xscreensaver-5.29-mga-utf8.patch
Patch10:	xscreensaver-5.35-mga-disable-too-old-warning.patch
Requires:	xscreensaver-common = %{version}-%{release}
Requires:	fortune-mod
Requires:	mageia-theme-screensaver
Requires:	xdg-utils
BuildRequires:	gdm
BuildRequires:	bc
BuildRequires:	fortune-mod
BuildRequires:	libjpeg-devel
BuildRequires:	pam-devel
BuildRequires:	xpm-devel
BuildRequires:	pkgconfig(libglade-2.0)
BuildRequires:	imagemagick
BuildRequires:	mesaglu-devel
BuildRequires:	freeglut-devel
BuildRequires:	pkgconfig(x11)
BuildRequires:	libxext-devel
BuildRequires:	libxi-devel
BuildRequires:	libxinerama-devel
BuildRequires:	libxmu-devel
BuildRequires:	libxrandr-devel
BuildRequires:	libxt-devel
BuildRequires:	libxxf86misc-devel
BuildRequires:	libxxf86vm-devel
BuildRequires:	makedepend
BuildRequires:	intltool
%if %enable_extrusion
BuildRequires:	libgle-devel
%endif
BuildRequires:	desktop-file-utils

%description
The xscreensaver package contains a variety of screen savers for your
mind-numbing, ambition-eroding, time-wasting, hypnotized viewing
pleasure.

Install the xscreensaver package if you need screen savers for use with
the X Window System.

%if %plf
This package is in the "tainted" section as it contains copyrighted images.
%endif

%package base
Summary:	A set of screen savers
Group:		Graphical desktop/Other
Requires:	xscreensaver-common = %{version}-%{release}
Conflicts:	xscreensaver < 5.00-2
Requires:	words
Requires:	xwininfo

%description base
Various screen savers used by Xscreensaver.

%package common
Summary:	Utilities used by xscreensaver screen savers
Group:		Graphical desktop/Other
Conflicts:	xscreensaver < 5.00-2
Obsoletes:	xscreensaver-utils < %{version}-%{release}
Provides:	xscreensaver-utils = %{version}-%{release}
Requires:	chbg

%description common
Utilities used by xscreensaver screen savers.

%package gl
Summary:	A set of GL screen savers
Group:		Graphical desktop/Other
Requires:	xscreensaver-common = %{version}-%{release}
Requires(post):	xscreensaver-common = %{version}-%{release}
Requires(postun):	xscreensaver-common = %{version}-%{release}
Requires:	appres

%description gl
The xscreensaver-gl package contains even more screen savers for your
mind-numbing, ambition-eroding, time-wasting, hypnotized viewing
pleasure. These screen savers require OpenGL or Mesa support.

Install the xscreensaver-gl package if you need more screen savers for
use with the X Window System and you have OpenGL or Mesa installed.

%if %plf
%package matrix
Summary:	The Matrix screen savers
Group:		Graphical desktop/Other
Requires:	xscreensaver-common = %{version}-%{release}

%description matrix
The xscreensaver-matrix package contains two screen savers for
xscreensaver based on the movie The Matrix. It is in the "tainted" section
because there might by copyright problems with the artwork used in this
screen savers.
%endif

%if %enable_extrusion
%package extrusion
Summary:	OpenGL screen saver
Group:		Graphical desktop/Other
Requires:	xscreensaver-common = %{version}-%{release}

%description extrusion
The xscreensaver-extrusion package contains the extrusion
screen savers for your mind-numbing, ambition-eroding, time-wasting,
hypnotized viewing pleasure. This screen saver requires OpenGL or Mesa
support.

This screen saver is in a separate package, because it is the only
application in %{distribution} which requires the GLE extrusion library.
%endif

%prep
%setup -q
#patch0 -p1 -b .drop_setgid
%patch1 -p1 -b .root
%patch2 -p1 -b .noGL
#patch3 -p1 -b .available
%if %{disable_inappropriate}
%patch4 -p1 -b .inappropriate
%endif

# WARNING this patch must ALWAYS be applied, if it fails, REGENERATE it !!!
%patch5 -p1 -b .defaultconfig

%patch8 -p1
%patch9 -p1
%patch10 -p1

%build
#needed by patches 11, 16
autoreconf -vfi
%configure2_5x \
    --enable-locking \
    --enable-root-passwd \
    --with-browser=xdg-open \
    --with-dpms-ext \
    --with-xinerama-ext \
    --with-xf86vmode-ext \
    --with-xf86gamma-ext \
    --with-randr-ext \
    --with-proc-interrupts \
    --with-login-manager=gdmflexiserver \
    --without-shadow \
    --with-pixbuf \
    --with-xpm \
    --with-jpeg \
    --with-xshm-ext \
    --with-xdbe-ext \
    --without-readdisplay \
    --without-setuid-hacks \
    --with-gtk \
    --without-motif \
    --with-pam \
    --with-gl \
    --with-image-directory="%{_datadir}/mga/screensaver" \
    --without-kerberos \
%if %enable_extrusion
    --with-gle
%else
    --without-gle
%endif

make depend
%make

%install
rm -rf %{buildroot} gl-extras.files base.files %{name}.lang
mkdir -p %{buildroot}%{_sysconfdir}/X11/app-defaults/
mkdir -p %{buildroot}%{_bindir}
mkdir -p %{buildroot}%{_bindir}
mkdir -p %{buildroot}%{_mandir}/man6
mkdir -p %{buildroot}%{_sysconfdir}/pam.d
mkdir -p %{buildroot}%{_libexecdir}/xscreensaver

# translate desktop file
intltool-merge -d ./po ./driver/screensaver-properties.desktop.in ./driver/screensaver-properties.desktop

make install_prefix=%{buildroot} bindir=%{_bindir} \
 KDEDIR=%{_prefix} GNOME_BINDIR=%{_bindir}  GNOME_DATADIR=%{_datadir} \
 mandir=%{_mandir} AD_DIR=%{_sysconfdir}/X11/app-defaults/ \
 gnulocaledir=%{_datadir}/locale install

cat<<EOF >README.GL
The xscreensaver-gl package contains even more screen savers for your
mind-numbing, ambition-eroding, time-wasting, hypnotized viewing
pleasure. These screen savers require OpenGL or Mesa support.

Install the xscreensaver-gl package if you need more screen savers for
use with the X Window System and you have OpenGL or Mesa installed.
EOF

desktop-file-install \
  --remove-category="Application" \
  --remove-category="AdvancedSettings" \
  --remove-category="Appearance" \
  --dir %{buildroot}%{_datadir}/applications %{buildroot}%{_datadir}/applications/*

%if 0
#icons
mkdir -p %{buildroot}%{_datadir}/pixmaps
mkdir -p %{buildroot}%{_iconsdir}/hicolor/{16x16,32x32,48x48}/apps
cp %{SOURCE1}  %{buildroot}%{_datadir}/pixmaps
convert -scale 16x16 %{SOURCE1} %{buildroot}%{_iconsdir}/hicolor/16x16/apps/%{name}.png
convert -scale 32x32 %{SOURCE1} %{buildroot}%{_iconsdir}/hicolor/32x32/apps/%{name}.png
ln -s %{_datadir}/pixmaps/xscreensaver-capplet.png %{buildroot}%{_iconsdir}/hicolor/48x48/apps/%{name}.png
%endif

#remove unpackaged files
rm -f %{buildroot}%{_datadir}/xscreensaver/config/xjack.xml
rm -f %{buildroot}%{_mandir}/man6/xjack.6  
rm -f  %{buildroot}%{_libexecdir}/xscreensaver/xjack

%if ! %plf
rm -rf %{buildroot}%{_libexecdir}/xscreensaver/*matrix
rm -rf %{buildroot}%{_mandir}/man6/*matrix*
rm -rf %{buildroot}%{_datadir}/xscreensaver/config/*matrix*
%endif
%if ! %enable_extrusion
rm -f %{buildroot}%{_datadir}/xscreensaver/config/extrusion.xml
rm -f %{buildroot}%{_mandir}/man6/extrusion.6
%endif

%find_lang %{name}

# This function prints a list of things that get installed.
# It does this by parsing the output of a dummy run of "make install".
#
list_files() {
  make -s install_prefix=%{buildroot} mandir=%{_mandir}/ \
  bindir=%{_bindir} INSTALL=true "$@"	\
   | sed -n -e 's@.* \(/[^ ]*\)$@\1@p'				\
   | sed    -e "s@^%{buildroot}@@"				\
	    -e "s@/[a-z][a-z]*/\.\./@/@"			\
   | sed    -e 's@\(.*/man/.*\)@\1\*@'				\
   | sed    -e 's@\(.*/app-defaults/\)@%config \1@'		\
	    -e 's@\(.*/pam\.d/\)@%config(missingok) \1@'	\
   | sort
}

# Generate three lists of files for the three packages.
#
dd=%{_builddir}/%{name}-%{version}
( cd hacks/glx ; list_files install > $dd/gl-extras.files)
( cd hacks     ; list_files install > $dd/base.files)

#gw remove the files we don't package:
perl -pi -e "s/.*(themed|xjack|matrix|extrusion).*//" gl-extras.files base.files

%find_lang %{name}

%post gl
sed -i -e 's/\A-\s+GL:/ GL:/' %{_sysconfdir}/X11/app-defaults/XScreenSaver

%postun gl
sed -i -e '/\A\s*GL:/ and print "- $_" or print "$_"' %{_sysconfdir}/X11/app-defaults/XScreenSaver

%files -f %{name}.lang
%config(noreplace) %{_sysconfdir}/pam.d/xscreensaver
%doc README
%{_mandir}/man1/xscreensaver-command.1*
%{_mandir}/man1/xscreensaver-demo.1*
%{_mandir}/man1/xscreensaver.1*
%attr(755,root,chkpwd) %{_bindir}/xscreensaver
%{_bindir}/xscreensaver-command
%{_bindir}/xscreensaver-demo
%dir %{_datadir}/xscreensaver
%{_datadir}/xscreensaver/glade
%{_datadir}/applications/*
%{_datadir}/pixmaps/*
%{_datadir}/xscreensaver/config/themed.xml
#{_iconsdir}/hicolor/*/apps/*.png

%files common 
%config(noreplace) %{_sysconfdir}/X11/app-defaults/*
%dir %{_libexecdir}/%{name}
%{_bindir}/xscreensaver-getimage
%{_bindir}/xscreensaver-getimage-file
%{_bindir}/xscreensaver-getimage-video
%{_bindir}/xscreensaver-text
%{_mandir}/man1/xscreensaver-getimage*
%{_mandir}/man1/xscreensaver-text.1*
%dir %{_datadir}/%{name}/config
%{_datadir}/%{name}/config/README

%files base -f base.files
%exclude %{_datadir}/xscreensaver/config/themed.xml

%files gl -f gl-extras.files
%doc README.GL

%if %enable_extrusion
%files extrusion
%doc README.GL
%{_datadir}/xscreensaver/config/extrusion.xml
%{_mandir}/man6/extrusion.6*  
%{_libexecdir}/xscreensaver/extrusion
%endif

%if %plf
%files matrix
%doc README.GL
%{_mandir}/man6/xmatrix.6*
%{_mandir}/man6/glmatrix.6*
%{_datadir}/xscreensaver/config/glmatrix.xml
%{_datadir}/xscreensaver/config/xmatrix.xml
%{_libexecdir}/xscreensaver/xmatrix
%{_libexecdir}/xscreensaver/glmatrix
%endif


%changelog
* Wed Oct 12 2016 akien <akien> 5.36-2.mga6
+ Revision: 1060561
- Build in Core

* Wed Oct 12 2016 ns80 <ns80> 5.36-1.mga6.tainted
+ Revision: 1060465
- new version 5.36

* Tue May 31 2016 ns80 <ns80> 5.35-4.mga6.tainted
+ Revision: 1019545
- new version of version 5.35
- drop patch incorrect-comments (problem solved upstream)

* Tue May 24 2016 luigiwalser <luigiwalser> 5.35-3.mga6
+ Revision: 1018173
- actually remove invalid comments

* Tue May 24 2016 ns80 <ns80> 5.35-2.mga6.tainted
+ Revision: 1018152
+ rebuild (emptylog)

* Tue May 24 2016 ns80 <ns80> 5.35-1.mga6
+ Revision: 1018145
- new version 5.35

* Wed Feb 17 2016 umeabot <umeabot> 5.34-3.mga6.tainted
+ Revision: 963653
- Mageia 6 Mass Rebuild

* Mon Oct 26 2015 ns80 <ns80> 5.34-2.mga6.tainted
+ Revision: 895578
+ rebuild (emptylog)

* Mon Oct 26 2015 ns80 <ns80> 5.34-1.mga6.tainted
+ Revision: 895532
- new version 5.34 which corrects a security issue (mga#17012)

* Tue Sep 01 2015 alexl <alexl> 5.33-4.mga6.tainted
+ Revision: 871711
- add GenericName
- create translated desktop file

* Tue Jul 07 2015 ns80 <ns80> 5.33-3.mga6.tainted
+ Revision: 852386
- Add patch disable-too-old-warning to get rid of warnings saying that this
  version is too old (mga#16292)

* Mon Jul 06 2015 ns80 <ns80> 5.33-2.mga6.tainted
+ Revision: 851854
- Replace PLF with tainted section

* Thu Jul 02 2015 wally <wally> 5.33-1.mga6
+ Revision: 849521
- new version 5.33
- rediff defaultconfig patch

* Thu Jan 22 2015 akien <akien> 5.29-6.mga5
+ Revision: 811855
- Fix truncated date on xscreensaver unlock (mga#11743, ns80)

* Tue Nov 11 2014 alexl <alexl> 5.29-5.mga5
+ Revision: 796490
- update utf8 patch (mga#11743)

* Sun Nov 02 2014 alexl <alexl> 5.29-4.mga5
+ Revision: 795178
- fix UTF-8 -> ISO-8859-1 issue (mga#11743)

* Wed Oct 15 2014 umeabot <umeabot> 5.29-3.mga5
+ Revision: 749022
- Second Mageia 5 Mass Rebuild

* Tue Sep 16 2014 umeabot <umeabot> 5.29-2.mga5
+ Revision: 690768
- Mageia 5 Mass Rebuild

* Thu Jun 12 2014 luigiwalser <luigiwalser> 5.29-1.mga5
+ Revision: 635900
- 5.29
- remove upstreamed patches

* Thu May 29 2014 luigiwalser <luigiwalser> 5.27-1.mga5
+ Revision: 627736
- 5.27

* Sat Jan 11 2014 luigiwalser <luigiwalser> 5.26-3.mga4
+ Revision: 566241
- starwars is in gl subpackage, move appres requiers there

* Thu Jan 02 2014 doktor5000 <doktor5000> 5.26-2.mga4
+ Revision: 563983
- xscreensaver-common requires appres for star wars

* Thu Dec 12 2013 luigiwalser <luigiwalser> 5.26-1.mga4
+ Revision: 556410
- 5.26
- xscreensaver-base requires xwininfo for webcollage

* Thu Nov 14 2013 luigiwalser <luigiwalser> 5.23-1.mga4
+ Revision: 551146
- 5.23

* Sat Oct 19 2013 umeabot <umeabot> 5.22-2.mga4
+ Revision: 530189
- Mageia 4 Mass Rebuild

* Sat Jul 20 2013 luigiwalser <luigiwalser> 5.22-1.mga4
+ Revision: 456581
- 5.22

* Tue Feb 12 2013 luigiwalser <luigiwalser> 5.21-1.mga3
+ Revision: 397946
- 5.21

* Mon Jan 14 2013 umeabot <umeabot> 5.20-2.mga3
+ Revision: 387385
- Mass Rebuild - https://wiki.mageia.org/en/Feature:Mageia3MassRebuild

* Fri Oct 19 2012 luigiwalser <luigiwalser> 5.20-1.mga3
+ Revision: 308291
- 5.20

* Sat Jul 28 2012 luigiwalser <luigiwalser> 5.19-1.mga3
+ Revision: 275388
- 5.19

* Wed Jul 04 2012 luigiwalser <luigiwalser> 5.17-1.mga3
+ Revision: 267775
- add fedora patch to fix build
- revert to 5.17 (5.18 broken upstream)
- 5.18

* Sat Apr 28 2012 luigiwalser <luigiwalser> 5.15-4.mga2
+ Revision: 234155
- revert previous incorrect change

* Fri Apr 27 2012 dams <dams> 5.15-3.mga2
+ Revision: 233475
- 'mageia-theme-screensaver' is now a 'suggests' and not a 'require'

* Sun Mar 04 2012 luigiwalser <luigiwalser> 5.15-2.mga2
+ Revision: 218242
- use mageia-theme-screensaver by default
- fix image directory
- remove obsolete configure options

* Tue Nov 01 2011 zezinho <zezinho> 5.15-1.mga2
+ Revision: 160707
- new version

* Tue Aug 30 2011 fwang <fwang> 5.14-3.mga2
+ Revision: 136308
- cleanup brs
- drop mandriva stuff
- new version 5.14

* Sun Jan 23 2011 ahmad <ahmad> 5.12-3.mga1
+ Revision: 34893
- comment out all the gdadou stuff
- use an alternative defaultconfig patch
- disable the requires on mageia-theme-screensaver, doesn't exist yet
- drop old conflicts
- re-enumerate the patches
- configure with --with-image-directory="%%{_datadir}/backrounds"
- don't use xscreensaver-capplet.png, I don't know what license it uses or where
  it comes from
- drop old/unneeded scriptlets
- imported package xscreensaver

